# remirepo/fedora spec file for php-oneup-flysystem-bundle
#
# Copyright (c) 2018-2019 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global gh_commit    bf8b1bdc4fca6e0ad072ff917b9c9e792d682588
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     1up-lab
%global gh_project   OneupFlysystemBundle
# Packagist
%global pk_vendor    oneup
%global pk_project   flysystem-bundle
# Namespace
%global ns_vendor    Oneup
%global ns_project   FlysystemBundle
%global php_home     %{_datadir}/php
# Disabled for now as missing dependencies ("require-dev")
%global with_tests   0%{?_with_tests:1}

Name:           php-%{pk_vendor}-%{pk_project}
Version:        3.4.0
Release:        1%{?gh_date:.%{gh_date}git%{gh_short}}%{?dist}
Summary:        Conversion of unicode, HTML and shortcode emoji

License:        MIT
URL:            https://github.com/%{gh_owner}/%{gh_project}
Source0:        https://github.com/%{gh_owner}/%{gh_project}/archive/%{gh_commit}/%{name}-%{version}-%{?gh_short}.tar.gz

BuildArch:      noarch
%if %{with_tests}
# For tests
BuildRequires:  php(language) >= 7.0
BuildRequires:  php-reflection
BuildRequires:  php-simplexml
BuildRequires:  php-ftp
BuildRequires:  php-spl
%if 0%{?fedora} >= 27 || 0%{?rhel} >=8
BuildRequires: (php-composer(symfony/config)               >= 3.4    with php-composer(symfony/config)               < 6)
BuildRequires: (php-composer(symfony/dependency-injection) >= 3.4    with php-composer(symfony/dependency-injection) < 6)
BuildRequires: (php-composer(symfony/http-kernel)          >= 3.4    with php-composer(symfony/http-kernel)          < 6)
BuildRequires: (php-composer(league/flysystem)             >= 1.0.26 with php-composer(league/flysystem)             < 2)
%else
BuildRequires:  php-symfony3-config                    >= 3.4
BuildRequires:  php-symfony3-dependency-injection      >= 3.4
BuildRequires:  php-symfony3-http-kernel               >= 3.4
BuildRequires:  php-league-flysystem                   >= 1.0.26
%endif
# From composer.json, "require-dev": {
#    "require-dev": {
#        "phpunit/phpunit": "^6.4",
#        "symfony/finder": "^3.4|^4.0|^5.0",
#        "symfony/browser-kit": "^3.4|^4.0|^5.0",
#        "symfony/asset": "^3.4|^4.0|^5.0",
#        "symfony/framework-bundle": "^3.4|^4.0|^5.0",
#        "symfony/templating": "^3.4|^4.0|^5.0",
#        "symfony/translation": "^3.4|^4.0|^5.0",
#        "symfony/yaml": "^3.4|^4.0|^5.0",
#        "league/flysystem-aws-s3-v2": "^1.0",
#        "league/flysystem-azure-blob-storage": "^0.1",
#        "league/flysystem-cached-adapter": "^1.0",
#        "spatie/flysystem-dropbox": "^1.0",
#        "league/flysystem-gridfs": "^1.0",
#        "league/flysystem-memory": "^1.0",
#        "league/flysystem-rackspace": "^1.0",
#        "league/flysystem-sftp": "^1.0",
#        "league/flysystem-webdav": "^1.0",
#        "league/flysystem-ziparchive": "^1.0",
#        "twistor/flysystem-stream-wrapper": "^1.0",
#        "litipk/flysystem-fallback-adapter": "^0.1",
#        "jenko/flysystem-gaufrette": "^1.0",
#        "superbalist/flysystem-google-storage": "^4.0",
#        "league/flysystem-replicate-adapter": "^1.0"
%global phpunit %{_bindir}/phpunit6
%if 0%{?fedora} >= 27 || 0%{?rhel} >=8
BuildRequires: (php-composer(symfony/finder)           >= 3.4    with php-composer(symfony/finder)           < 6)
BuildRequires: (php-composer(symfony/browser-kit)      >= 3.4    with php-composer(symfony/browser-kit)      < 6)
BuildRequires: (php-composer(symfony/asset)            >= 3.4    with php-composer(symfony/asset)            < 6)
BuildRequires: (php-composer(symfony/framework-bundle) >= 3.4    with php-composer(symfony/framework-bundle) < 5)
BuildRequires: (php-composer(symfony/templating)       >= 3.4    with php-composer(symfony/templating)       < 6)
BuildRequires: (php-composer(symfony/translation)      >= 3.4    with php-composer(symfony/translation)      < 6)
BuildRequires: (php-composer(symfony/yaml)             >= 3.4    with php-composer(symfony/yaml)             < 6)
%else
BuildRequires:  php-symfony3-finder           >= 3.4
BuildRequires:  php-symfony3-browser-kit      >= 3.4
BuildRequires:  php-symfony3-asset            >= 3.4
BuildRequires:  php-symfony3-framework-bundle >= 3.4
BuildRequires:  php-symfony3-templating       >= 3.4
BuildRequires:  php-symfony3-translation      >= 3.4
BuildRequires:  php-symfony3-yaml             >= 3.4
%endif
BuildRequires: %{phpunit}
# Autoloader
BuildRequires:  php-composer(fedora/autoloader)
%endif

# From composer.json, "require": {
#        "php": "^7.0",
#        "symfony/config": "^3.4|^4.0|^5.0",
#        "symfony/dependency-injection": "^3.4|^4.0|^5.0",
#        "symfony/http-kernel": "^3.4|^4.0|^5.0",
#        "league/flysystem": "^1.0.26"
Requires:       php(language) >= 7.0
%if 0%{?fedora} >= 27 || 0%{?rhel} >=8
Requires:      (php-composer(symfony/config)               >= 3.4    with php-composer(symfony/config)               < 6)
Requires:      (php-composer(symfony/dependency-injection) >= 3.4    with php-composer(symfony/dependency-injection) < 6)
Requires:      (php-composer(symfony/http-kernel)          >= 3.4    with php-composer(symfony/http-kernel)          < 6)
Requires:      (php-composer(league/flysystem)             >= 1.0.26 with php-composer(league/flysystem)             < 2)
%else
Requires:       php-symfony3-config                    >= 3.4
Requires:       php-symfony3-dependency-injection      >= 3.4
Requires:       php-symfony3-http-kernel               >= 3.4
Requires:       php-league-flysystem                   >= 1.0.26
%endif
# From phpcompatinfo report for version 3.0.2
Requires:       php-reflection
Requires:       php-simplexml
Requires:       php-ftp
Requires:       php-spl
# Autoloader
Requires:       php-composer(fedora/autoloader)

Provides:       php-composer(%{pk_vendor}/%{pk_project}) = %{version}


%description
A PHP library simplifying the conversion of unicode, HTML and shortcode emoji.

Autoloader: %{_datadir}/php/%{ns_vendor}/%{ns_project}/autoload.php


%prep
%setup -q -n %{gh_project}-%{gh_commit}


%build
: Create autoloader
cat <<'AUTOLOAD' | tee autoload.php
<?php
/* Autoloader for %{name} and its dependencies */
require_once '%{_datadir}/php/Fedora/Autoloader/autoload.php';

\Fedora\Autoloader\Autoload::addPsr4('%{ns_vendor}\\%{ns_project}\\', __DIR__);
\Fedora\Autoloader\Dependencies::required([
    [
        '%{_datadir}/php/Symfony5/Component/Config/autoload.php',
        '%{_datadir}/php/Symfony4/Component/Config/autoload.php',
        '%{_datadir}/php/Symfony3/Component/Config/autoload.php',
    ], [
        '%{_datadir}/php/Symfony5/Component/DependencyInjection/autoload.php',
        '%{_datadir}/php/Symfony4/Component/DependencyInjection/autoload.php',
        '%{_datadir}/php/Symfony3/Component/DependencyInjection/autoload.php',
    ], [
        '%{_datadir}/php/Symfony5/Component/HttpKernel/autoload.php',
        '%{_datadir}/php/Symfony4/Component/HttpKernel/autoload.php',
        '%{_datadir}/php/Symfony3/Component/HttpKernel/autoload.php',
    ],
    '%{_datadir}/php/League/Flysystem/autoload.php',
]);
AUTOLOAD


%install
mkdir -p                   %{buildroot}%{_datadir}/php/%{ns_vendor}/%{ns_project}
cp -p *php                 %{buildroot}%{_datadir}/php/%{ns_vendor}/%{ns_project}/
cp -pr DependencyInjection %{buildroot}%{_datadir}/php/%{ns_vendor}/%{ns_project}/DependencyInjection
cp -pr StreamWrapper       %{buildroot}%{_datadir}/php/%{ns_vendor}/%{ns_project}/StreamWrapper
cp -pr Resources           %{buildroot}%{_datadir}/php/%{ns_vendor}/%{ns_project}/Resources


%check
%if %{with_tests}
cat << 'EOF' | tee Tests/bootstrap.php
<?php
require_once '%{buildroot}%{_datadir}/php/%{ns_vendor}/%{ns_project}/autoload.php';
\Fedora\Autoloader\Autoload::addPsr4('%{ns_vendor}\\%{ns_project}\\', dirname(__DIR__));
\Fedora\Autoloader\Dependencies::required([
    [
        '%{_datadir}/php/Symfony5/Component/Finder/autoload.php',
        '%{_datadir}/php/Symfony4/Component/Finder/autoload.php',
        '%{_datadir}/php/Symfony3/Component/Finder/autoload.php',
    ], [
        '%{_datadir}/php/Symfony5/Component/BrowserKit/autoload.php',
        '%{_datadir}/php/Symfony4/Component/BrowserKit/autoload.php',
        '%{_datadir}/php/Symfony3/Component/BrowserKit/autoload.php',
    ], [
        '%{_datadir}/php/Symfony5/Component/Asset/autoload.php',
        '%{_datadir}/php/Symfony4/Component/Asset/autoload.php',
        '%{_datadir}/php/Symfony3/Component/Asset/autoload.php',
    ], [
        '%{_datadir}/php/Symfony5/Bundle/FrameworkBundle/autoload.php',
        '%{_datadir}/php/Symfony4/Bundle/FrameworkBundle/autoload.php',
        '%{_datadir}/php/Symfony3/Bundle/FrameworkBundle/autoload.php',
    ], [
        '%{_datadir}/php/Symfony5/Component/Templating/autoload.php',
        '%{_datadir}/php/Symfony4/Component/Templating/autoload.php',
        '%{_datadir}/php/Symfony3/Component/Templating/autoload.php',
    ], [
        '%{_datadir}/php/Symfony5/Component/Translation/autoload.php',
        '%{_datadir}/php/Symfony4/Component/Translation/autoload.php',
        '%{_datadir}/php/Symfony3/Component/Translation/autoload.php',
    ], [
        '%{_datadir}/php/Symfony5/Component/Yaml/autoload.php',
        '%{_datadir}/php/Symfony4/Component/Yaml/autoload.php',
        '%{_datadir}/php/Symfony3/Component/Yaml/autoload.php',
    ],
]);
EOF

ret=0
for cmd in php php71 php72 php73 php74; do
  rm -rf Tests/App/cache
  if which $cmd; then
    $cmd %{phpunit} \
      --no-coverage \
      --verbose
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license Resources/meta/LICENSE
%doc composer.json
%doc *.md
%doc Resources/doc
%dir %{php_home}/%{ns_vendor}/
     %{php_home}/%{ns_vendor}/%{ns_project}
%exclude %{php_home}/%{ns_vendor}/%{ns_project}/Resources/doc
%exclude %{php_home}/%{ns_vendor}/%{ns_project}/Resources/meta


%changelog
* Thu Jan  9 2020 Remi Collet <remi@remirepo.net> - 3.4.0-1
- update to 3.4.0
- drop depencency on symfony/framework-bundle
- add dependency on symfony/config, symfony/dependency-injection
  and symfony/http-kernel

* Mon Dec  9 2019 Remi Collet <remi@remirepo.net> - 3.3.0-1
- update to 3.3.0
- raise dependency on Symfony 3.4
- allow Symfony 5

* Mon Nov 25 2019 Remi Collet <remi@remirepo.net> - 3.2.0-1
- update to 3.2.0

* Fri Apr 26 2019 Remi Collet <remi@remirepo.net> - 3.1.0-1
- update to 3.1.0

* Mon Dec  3 2018 Remi Collet <remi@remirepo.net> - 3.0.3-1
- update to 3.0.3

* Wed Nov 28 2018 Remi Collet <remi@remirepo.net> - 3.0.2-1
- initial package, version 3.0.2
- add upstream patch for Symfony4
